//
//  TEWindow.swift
//  TextEditDoc
//
//  Created by narita on 2018/10/16.
//  Copyright © 2018 narita. All rights reserved.
//

import Cocoa

class TEWindow: NSWindow
{
    // MARK: - class methods
    
    // MARK: - init methods
    
    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    // MARK: - restorableState methods
    
    // MARK: - life cycle methods
    
    // MARK: - action methods
    
    // MARK: - event handling methods
    
    override func performKeyEquivalent(with event: NSEvent) -> Bool
    {
        // 修飾キーでコマンドキーだけが押されているか否か
        if  (
                event.type == NSEvent.EventType.keyDown
            )
            &&
            (
                    ( event.modifierFlags.rawValue & NSEvent.ModifierFlags.command.rawValue)
                ==
                    NSEvent.ModifierFlags.command.rawValue
            )
        {
            if let string = event.characters
            {
                if let theTabs = self.tabbedWindows as Array<NSWindow>?
                {
                    // 数字の1から9と0までのキーが押されているか
                    switch string
                    {
                        case "1"..."9":
                            
                            let theNum = (string as NSString).integerValue - 1
                            
                            if theTabs.count > theNum
                            {
                                theTabs[theNum].makeKeyAndOrderFront(self)
                                return true
                            }
                        
                        case "0":
                            if theTabs.count > 9
                            {
                                theTabs[9].makeKeyAndOrderFront(self)
                                return true
                            }
                        
                        default:
                            return super.performKeyEquivalent(with: event)
                    }
                    
                }
            }
        }
        // ここで、キーイベントのハックをしても良い....?
        return super.performKeyEquivalent(with: event)
    }
    
    
    // MARK: - drawing methods
    
    // MARK: - delegate/datasource methods
    
    // MARK: - accessor methods (in pairs)
    
    // MARK: - Utility methods

}
